<?php

/**
 * @package Module Barcode Cooker
 * @version 5.0.1
 * @author Glenn Arkell
 * @copyright (C) 2013- Glenn Arkell
 * @credits Thanks to The Cache at perkiset's for the code from his forum
**/

namespace GlennArkell\Component\Gausers\Administrator\Helper;

defined( '_JEXEC' ) or die( 'Restricted access' );

use \Joomla\CMS\Factory;
use \Joomla\Filesystem\Path;

class BchelperHelper
{
        public $bcHeight, $bcThinWidth, $bcThickWidth, $bcFontSize, $mode;
        
        function __construct($mode='jpeg', $height=80, $thin=2, $thick=3, $fSize=2)
        {
        
            $this->bcHeight = $height;
            $this->bcThinWidth = $thin;
            $this->bcThickWidth = $this->bcThinWidth * $thick;
            $this->fontSize = $fSize;
            $this->mode = $mode;
            $this->outMode = array('gif'=>'gif', 'png'=>'png', 'jpeg'=>'jpeg', 'wbmp'=>'vnd.wap.wbmp');
            $this->codeMap = array(
                    '0'=>'010000101', '1'=>'100100001', '2'=>'001100001', '3'=>'101100000',
                    '4'=>'000110001', '5'=>'100110000', '6'=>'001110000', '7'=>'000100101',
                    '8'=>'100100100', '9'=>'001100100',
                    'A'=>'100001001', 'B'=>'001001001', 'C'=>'101001000', 'D'=>'000011001',
                    'E'=>'100011000', 'F'=>'001011000', 'G'=>'000001101', 'H'=>'100001100',
                    'I'=>'001001100', 'J'=>'000011100', 'K'=>'100000011', 'L'=>'001000011',
                    'M'=>'101000010', 'N'=>'000010011', 'O'=>'100010010', 'P'=>'001010010',
                    'Q'=>'000000111', 'R'=>'100000110', 'S'=>'001000110', 'T'=>'000010110',
                    'U'=>'110000001', 'V'=>'011000001', 'W'=>'111000000', 'X'=>'010010001',
                    'Y'=>'110010000', 'Z'=>'011010000', '#'=>'000101010',
                    ' '=>'011000100', '$'=>'010101000', '%'=>'000101010', '*'=>'010010100',
                    '+'=>'010001010', '-'=>'000110100', '.'=>'110000100', '/'=>'010100010' );
        }

        public function bcBuild($text='', $showText=true, $fileName=null)
        {
        
            if (trim($text) <= ' ') {
	            throw new exception('barCode::bcBuild - must be passed text to operate');
			}
            if (!$fileType = $this->outMode[$this->mode]) {
	            throw new exception("barCode::bcBuild - unrecognized output format ({$this->mode})");
			}

            if (!function_exists("image{$this->mode}")) {
	            throw new exception("barCode::bcBuild - unsupported output format ({$this->mode} - check phpinfo)");
			}

            $text  =  strtoupper($text);
            $dispText = "* BECs Shed Member - $text *";
            $text = str_replace(' ','-', $text);
            $text = str_replace('(','-', $text);
            $text = str_replace(')','-', $text);
            $image_name = $text;
            $text = "*$text*"; // adds start and stop chars
            $textLen  =  strlen($text);
            $barcodeWidth  =  $textLen * (7 * $this->bcThinWidth + 3 * $this->bcThickWidth) - $this->bcThinWidth;
            $im = imagecreate($barcodeWidth, $this->bcHeight);
            $black = imagecolorallocate($im, 0, 0, 0);
            $white = imagecolorallocate($im, 255, 255, 255);
            imagefill($im, 0, 0, $white);
            $xpos = 0;

            for ($idx=0; $idx<$textLen; $idx++) {
                if (!$char = $text[$idx]) { $char = '-'; }
                for ($ptr=0; $ptr<=8; $ptr++) {
                    $elementWidth = ($this->codeMap[$char][$ptr]) ? $this->bcThickWidth : $this->bcThinWidth;
                    if (($ptr + 1) % 2) {
	                    imagefilledrectangle($im, $xpos, 0, $xpos + $elementWidth-1, $this->bcHeight, $black);
                    }
                    $xpos += $elementWidth;
                }
        
                $xpos += $this->bcThinWidth;
            }
        
            if ($showText) {
                $pxWid = imagefontwidth($this->fontSize) * strlen($dispText) + 10;
                $pxHt = imagefontheight($this->fontSize) + 2;
                $bigCenter = $barcodeWidth / 2;
                $textCenter = $pxWid / 2;
                imagefilledrectangle($im, $bigCenter - $textCenter, $this->bcHeight - $pxHt, $bigCenter + $textCenter, $this->bcHeight, $white);
                imagestring($im, $this->fontSize, ($bigCenter - $textCenter) + 5, ($this->bcHeight - $pxHt) + 1, $dispText, $black);
            }
            
            $badMode = false;
        
            if (!$fileName) {
				header("Content-type:  image/{$fileType}");
			}
            $path = Path::clean( JPATH_SITE . '/images/members/barcodes/');
            $filelink = htmlspecialchars(Uri::root().'/images/members/barcodes', ENT_QUOTES);

            switch($this->mode) {
                case 'gif': 
                    //imagegif($im, $fileName);
                    //$bcimagename = sprintf("%d.gif", time());
                    $bcimagename = sprintf("%s%s.gif", $path, $image_name);
                    imagegif($im, $bcimagename);
                    $link_to_file = $filelink.'/'.$image_name.'.'.$this->mode;
                    Factory::getApplication()->setUserState('com_gausers.barcode.data', $link_to_file);
                    break;
                case 'png':
                    $bcimagename = sprintf("%s%s.png", $path, $image_name);
                    imagepng($im, $bcimagename);
                    $link_to_file = $filelink.'/'.$image_name.'.'.$this->mode;
                    Factory::getApplication()->setUserState('com_gausers.barcode.data', $link_to_file);
                    break;
                case 'jpeg':
                    $bcimagename = sprintf("%s%s.jpg", $path, $image_name);
                    imagejpeg($im, $bcimagename);
                    $link_to_file = $image_name.'.jpg';
                    Factory::getApplication()->setUserState('com_gausers.barcode.data', $link_to_file);
                    break;
                case 'wbmp':
                    imagewbmp($im, $fileName);
                    break;
                default:
                    $badMode = true;
            }

            imagedestroy($im);
            if ($badMode) {
                throw new \Exception("barCode: Unknown Graphics Type '{$this->mode}'");
            }
        }
}
?>
